// C Header File
// Created 26/06/03; 14:26:28

// to compile for Fargo II, uncomment the defines in global.h and asm_funcs.asm and change the compilation options

// non fargo:
//gcc -Os -W -Wall -mregparm -fomit-frame-pointer -freg-relative-a4 -mno-bss -ffunction-sections
//as -l --short-jumps
//a68k -g -t -f -u

// fargo: -Os -W -Wall
// gcc -Os -W -Wall -mregparm -fomit-frame-pointer -mno-bss -ffunction-sections
// as
// a68k -g -t -f -u

//#define _fargo

#ifdef _fargo

typedef unsigned short HANDLE;

#define CALCULATOR 1

#define GRAYDBUFFER_SIZE 7688
enum GrayPlanes {LIGHT_PLANE = 0, DARK_PLANE = 1};

#define GrayOn gray4lib__0000
#define GrayOff gray4lib__0001
#define gray4lib__plane0 gray4lib__0002
#define gray4lib__plane1 gray4lib__0003
#define choosescreen graphlib__000D
#define clr_scr	graphlib__0005

extern void* gray4lib__plane0;
extern void* gray4lib__plane1;
extern unsigned short choosescreen;
short GrayOn( void );
void GrayOff( void );
void clr_scr( register void *scr asm("%a1") );

#define HeapFree tios__0002
#define HeapAlloc tios__0003
#define sprintf tios__000f
#define DrawStrXY tios__0011
#define FontSetSys tios__0012
#define PortSet tios__0015
#define tios_globals tios__001c
#define memcpy tios__0034
#define rand tios__0037
#define srand tios__0038

#define DEREF(_HANDLE) ((_HANDLE<<2)+&tios_globals+0x0192)
#define peekIO(port) (*((volatile unsigned char*)(long)(port)))
#define random(_val) (rand()%_val)

#define GrayDBufSetAMSPlane(i,x) (PortSet(GrayDBufGetPlane(i,x),239,127))
#define printf_xy(x,y,f...) ({char __s[50];sprintf(__s ,##f);DrawStrXY(x,y,__s,4);})

extern void tios_globals;
HANDLE HeapAlloc (unsigned long Size);
void HeapFree (HANDLE Handle);
short rand (void);
void srand (unsigned long seed);
unsigned char FontSetSys (short Font);
void *memcpy (void *dest, const void *src, unsigned long len);
void DrawStrXY(short x, short y, char *string, short color);
void PortSet (void *vm_addr, short x_max, short y_max);
short sprintf (char *buffer, const char *format, ...);

#else
#include <tigcclib.h>         // Include All Header Files
#endif

// Macros: on-calc compatibility
#define Xmax (CALCULATOR?239:159)
#define Ymax (CALCULATOR?127:99)

// Macros: keys tests
#define K_ENTER (g & 0x0020)
#define K_ESC   (g & 0x0010)
#define K_UP    (g & 0x0001)
#define K_DOWN  (g & 0x0002)
#define K_RIGHT (g & 0x0004)
#define K_LEFT  (g & 0x0008)

// Sprites
#define spriteBD 0x7
#define spriteBG 0x8
#define spriteHD 0x9
#define spriteHG 0xA

// enums
enum e_MASKS  {COLOR_MASK=7,P1_MASK=8,P2_MASK=16,DATA_MASK=31,TEST_MASK=32,FILL_MASK=64};
enum e_COORDS {PLAYER1_X,PLAYER1_Y,PLAYER2_X,PLAYER2_Y};
enum e_TYPE   {PLAYER_VS_AI=1,PLAYER_VS_PLAYER=2};
enum e_PLAYER {PLAYER1,PLAYER2};
enum e_MENU   {FRAG,SIZE,TYPE};

// vars
extern short total[2];
extern unsigned char table[22][21];
extern unsigned char player_color[2];
extern unsigned char player;
extern unsigned char color;

extern short fragmentation;
extern short TABLE_WIDTH;
extern short TABLE_HEIGHT;
extern short game_type;

// C funcs
short game_menu ( void );
short main_menu ( void );
short winner_check ( void );
void draw_table ( short X, short Y );
void fill_table ( void );
void expand ( void );
void AI_do ( void );

// Asm functions
short getkey ( void );
short wait_a_key ( void );
void wait_no_key ( void );
void CustomSprite16x15_or ( register unsigned short x asm("%d0"), register unsigned short y asm("%d1"), register unsigned short nbr asm("%d2"), register void *dest0 asm("%a0"), register void *dest1 asm("%a1") );
void SaveAndReplaceInts ( void );
void RestoreInts ( void );



